## Resource: User

The Directory API allows you to create and manage your account's users, user aliases, and user Google profile photos. For more information about common tasks, see the [User Accounts Developer's Guide](https://developers.google.com/workspace/admin/directory/v1/guides/manage-users.html) and the [User Aliases Developer's Guide](https://developers.google.com/workspace/admin/directory/v1/guides/manage-user-aliases.html).

| JSON representation |
|---|
| ``` { "id": string, "primaryEmail": string, "password": value, "hashFunction": string, "isAdmin": boolean, "isDelegatedAdmin": boolean, "agreedToTerms": boolean, "suspended": boolean, "changePasswordAtNextLogin": boolean, "ipWhitelisted": boolean, "name": { object (`https://developers.google.com/workspace/admin/directory/reference/rest/v1/users#UserName`) }, "kind": string, "etag": string, "emails": value, "externalIds": value, "relations": value, "aliases": [ string ], "isMailboxSetup": boolean, "customerId": string, "addresses": value, "organizations": value, "lastLoginTime": string, "phones": value, "suspensionReason": string, "thumbnailPhotoUrl": string, "languages": value, "posixAccounts": value, "creationTime": string, "nonEditableAliases": [ string ], "sshPublicKeys": value, "notes": value, "websites": value, "locations": value, "includeInGlobalAddressList": boolean, "keywords": value, "deletionTime": string, "gender": value, "thumbnailPhotoEtag": string, "ims": value, "customSchemas": value, "isEnrolledIn2Sv": boolean, "isEnforcedIn2Sv": boolean, "archived": boolean, "orgUnitPath": string, "recoveryEmail": string, "recoveryPhone": string, "isGuestUser": boolean, "guestAccountInfo": { object (`https://developers.google.com/workspace/admin/directory/reference/rest/v1/users#GuestAccountInfo`) }, "suspensionTime": string, "archivalTime": string } ``` |

| Fields ||
|---|---|
| `id` | `string` The unique ID for the user. A user `id` can be used as a user request URI's `userKey`. |
| `primaryEmail` | `string` The user's primary email address. This property is required in a request to create a user account. The `primaryEmail` must be unique and cannot be an alias of another user. |
| `password` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` Stores the password for the user account. The user's password value is required when creating a user account. It's optional when updating a user and should only be provided if the user is updating their account password. The password value is never returned in the API's response body. A password can contain any combination of ASCII characters, and must be between 8-100 characters. We recommend sending the `password` parameter as a hexadecimal-encoded hash value and setting `hashFunction` accordingly. If `hashFunction` is specified, the password must be a valid hash key. |
| `hashFunction` | `string` Stores the hash format of the `password` property. The following `hashFunction` values are allowed: - `MD5` - Accepts simple hex-encoded values. - `SHA-1` - Accepts simple hex-encoded values. - `crypt` - Compliant with the [C crypt library](https://en.wikipedia.org/wiki/Crypt_%28C%29). Supports the DES, MD5 (hash prefix `$1$`), SHA-256 (hash prefix `$5$`), and SHA-512 (hash prefix `$6$`) hash algorithms. If rounds are specified as part of the prefix, they must be 10,000 or fewer. |
| `isAdmin` | `boolean` Output only. Indicates a user with super administrator privileges. The `isAdmin` property can only be edited in the [Make a user an administrator](https://developers.google.com/workspace/admin/directory/v1/guides/manage-users.html#make_admin) operation ( [makeAdmin](https://developers.google.com/workspace/admin/directory/v1/reference/users/makeAdmin.html) method). If edited in the user [insert](https://developers.google.com/workspace/admin/directory/v1/reference/users/insert.html) or [update](https://developers.google.com/workspace/admin/directory/v1/reference/users/update.html) methods, the edit is ignored by the API service. |
| `isDelegatedAdmin` | `boolean` Output only. Indicates if the user is a delegated administrator. Delegated administrators are supported by the API but cannot create or undelete users, or make users administrators. These requests are ignored by the API service. Roles and privileges for administrators are assigned using the [Admin console](https://support.google.com/a/answer/33325). |
| `agreedToTerms` | `boolean` Output only. This property is `true` if the user has completed an initial login and accepted the Terms of Service agreement. |
| `suspended` | `boolean` Indicates if user is suspended. |
| `changePasswordAtNextLogin` | `boolean` Indicates if the user is forced to change their password at next login. This setting doesn't apply when [the user signs in via a third-party identity provider](https://support.google.com/a/answer/60224). |
| `ipWhitelisted` | `boolean` If `true`, the user's IP address is subject to a deprecated IP address [`allowlist`](https://support.google.com/a/answer/60752) configuration. |
| `name` | ``object (`https://developers.google.com/workspace/admin/directory/reference/rest/v1/users#UserName`)`` Holds the given and family names of the user, and the read-only `fullName` value. The maximum number of characters in the `givenName` and in the `familyName` values is 60. In addition, name values support unicode/UTF-8 characters, and can contain spaces, letters (a-z), numbers (0-9), dashes (-), forward slashes (/), and periods (.). For more information about character usage rules, see the [administration help center](https://support.google.com/a/answer/9193374). Maximum allowed data size for this field is 1KB. |
| `kind` | `string` Output only. The type of the API resource. For Users resources, the value is `admin#directory#user`. |
| `etag` | `string` Output only. ETag of the resource. |
| `emails` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of the user's email addresses. The maximum allowed data size is 10KB. <br /> |---|---|---| | **Fields** ||| | <br /> `emails[].address` <br /> | <br /> `string` <br /> | The user's email address. Also serves as the email ID. This value can be the user's primary email address or an alias. | | <br /> `emails[].customType` <br /> | <br /> `string` <br /> | If the email address `type` is `custom`, this property contains the custom value and must be set. | | <br /> `emails[].primary` <br /> | <br /> `boolean` <br /> | Indicates if this is the user's primary email. Only one entry can be marked as primary. | | <br /> `emails[].type` <br /> | <br /> `string` <br /> | The type of the email account. If set to `custom`, `customType` must also be set. Acceptable values: `custom`, `home`, `other`, `work`. | <br /> |
| `externalIds` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of external IDs for the user, such as an employee or network ID. The maximum allowed data size is 2KB. <br /> |---|---|---| | **Fields** ||| | <br /> `externalIds[].customType` <br /> | <br /> `string` <br /> | If the external ID `type` is `custom`, this property contains the custom value and must be set. | | <br /> `externalIds[].type` <br /> | <br /> `string` <br /> | The type of external ID. If set to `custom`, `customType` must also be set. Acceptable values: `account`, `custom`, `customer`, `login_id`, `network`, `organization`. | | <br /> `externalIds[].value` <br /> | <br /> `string` <br /> | The value of the external ID. | <br /> |
| `relations` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of the user's relationships to other users. The maximum allowed data size for this field is 2KB. For more information, see [Manage user accounts](https://developers.google.com/workspace/admin/directory/v1/guides/manage-users#user-relationships). <br /> |---|---|---| | **Fields** ||| | <br /> `relations[].customType` <br /> | <br /> `string` <br /> | If the relationship `type` is `custom`, this property contains the custom value and must be set. | | <br /> `relations[].type` <br /> | <br /> `string` <br /> | The type of relationship. If set to `custom`, `customType` must also be set. Acceptable values: - `admin_assistant` - `assistant` - `brother` - `child` - `custom` - `domestic_partner` - `dotted_line_manager` - `exec_assistant` - `father` - `friend` - `manager` - `mother` - `parent` - `partner` - `referred_by` - `relative` - `sister` - `spouse` | | <br /> `relations[].value` <br /> | <br /> `string` <br /> | The email address of the person the user is related to. | <br /> |
| `aliases[]` | `string` Output only. The list of the user's alias email addresses. |
| `isMailboxSetup` | `boolean` Output only. Indicates if the user's Google mailbox is created. This property is only applicable if the user has been assigned a Gmail license. |
| `customerId` | `string` Output only. The customer ID to [retrieve all account users](https://developers.google.com/workspace/admin/directory/v1/guides/manage-users.html#get_all_users). You can use the alias `my_customer` to represent your account's `customerId`. As a reseller administrator, you can use the resold customer account's `customerId`. To get a `customerId`, use the account's primary domain in the `domain` parameter of a [users.list](https://developers.google.com/workspace/admin/directory/v1/reference/users/list) request. |
| `addresses` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of the user's addresses. The maximum allowed data size is 10KB. <br /> |---|---|---| | **Fields** ||| | <br /> `addresses[].country` <br /> | <br /> `string` <br /> | Country. | | <br /> `addresses[].countryCode` <br /> | <br /> `string` <br /> | The country code. Uses the [ISO 3166-1](http://www.iso.org/iso/iso-3166-1_decoding_table) standard. | | <br /> `addresses[].customType` <br /> | <br /> `string` <br /> | If the address `type` is `custom`, this property contains the custom value and must be set. | | <br /> `addresses[].extendedAddress` <br /> | <br /> `string` <br /> | For extended addresses, such as an address that includes a sub-region. | | <br /> `addresses[].formatted` <br /> | <br /> `string` <br /> | A full and unstructured postal address. This is not synced with the structured address fields. Includes the following attributes: street address, P.O. box, city, state/province, ZIP/postal code, country/region. | | <br /> `addresses[].locality` <br /> | <br /> `string` <br /> | The town or city of the address. | | <br /> `addresses[].poBox` <br /> | <br /> `string` <br /> | The post office box, if present. | | <br /> `addresses[].postalCode` <br /> | <br /> `string` <br /> | The ZIP or postal code, if applicable. | | <br /> `addresses[].primary` <br /> | <br /> `boolean` <br /> | If this is the user's primary address. The addresses list may contain only one primary address. | | <br /> `addresses[].region` <br /> | <br /> `string` <br /> | The abbreviated province or state. | | <br /> `addresses[].sourceIsStructured` <br /> | <br /> `boolean` <br /> | Indicates if the user-supplied address was formatted. Formatted addresses are not currently supported. | | <br /> `addresses[].streetAddress` <br /> | <br /> `string` <br /> | The street address, such as `1600 Amphitheatre Parkway`. Whitespace within the string is ignored; however, newlines are significant. | | <br /> `addresses[].type` <br /> | <br /> `string` <br /> | The address type. If set to `custom`, `customType` must also be set. Acceptable values: `custom`, `home`, `other`, `work`. | <br /> |
| `organizations` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of organizations the user belongs to. The maximum allowed data size is 10KB. <br /> |---|---|---| | **Fields** ||| | <br /> `organizations[].costCenter` <br /> | <br /> `string` <br /> | The cost center of the user's organization. | | <br /> `organizations[].customType` <br /> | <br /> `string` <br /> | If the value of type is custom, this property contains the custom type. | | <br /> `organizations[].department` <br /> | <br /> `string` <br /> | Specifies the department within the organization, such as `sales` or `engineering`. | | <br /> `organizations[].description` <br /> | <br /> `string` <br /> | The description of the organization. | | <br /> `organizations[].domain` <br /> | <br /> `string` <br /> | The domain the organization belongs to. | | <br /> `organizations[].fullTimeEquivalent` <br /> | <br /> `integer` <br /> | The full-time equivalent millipercent within the organization (100000 = 100%). | | <br /> `organizations[].location` <br /> | <br /> `string` <br /> | The physical location of the organization. This does not need to be a fully qualified address. | | <br /> `organizations[].name` <br /> | <br /> `string` <br /> | The name of the organization. | | <br /> `organizations[].primary` <br /> | <br /> `boolean` <br /> | Indicates if this is the user's primary organization. A user may only have one primary organization. | | <br /> `organizations[].symbol` <br /> | <br /> `string` <br /> | Text string symbol of the organization. For example, the text symbol for Google is `GOOG`. | | <br /> `organizations[].title` <br /> | <br /> `string` <br /> | The user's title within the organization. For example, `member` or `engineer`. | | <br /> `organizations[].type` <br /> | <br /> `string` <br /> | The type of organization. Acceptable values: `domain_only`, `school`, `unknown`, `work`. | <br /> |
| `lastLoginTime` | `string` Output only. The last time the user logged into the user's account. The value is in [ISO 8601](https://www.w3.org/TR/NOTE-datetime) date and time format. The time is the complete date plus hours, minutes, and seconds in the form `YYYY-MM-DDThh:mm:ssTZD`. For example, `2010-04-05T17:30:04+01:00`. |
| `phones` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> A list of the user's phone numbers. The maximum allowed data size is 1KB. <br /> |---|---|---| | **Fields** ||| | <br /> `phones[].customType` <br /> | <br /> `string` <br /> | If the phone number `type` is `custom`, this property contains the custom value and must be set. | | <br /> `phones[].primary` <br /> | <br /> `boolean` <br /> | If `true`, this is the user's primary phone number. A user may only have one primary phone number. | | <br /> `phones[].type` <br /> | <br /> `string` <br /> | The type of phone number. If set to `custom`, `customType` must also be set. Acceptable values: `assistant`, `callback`, `car`, `company_main`, `custom`, `grand_central`, `home`, `home_fax`, `isdn`, `main`, `mobile`, `other`, `other_fax`, `pager`, `radio`, `telex`, `tty_tdd`, `work`, `work_fax`, `work_mobile`, `work_pager`. | | <br /> `phones[].value` <br /> | <br /> `string` <br /> | A human-readable phone number. It may be in any telephone number format. | <br /> |
| `suspensionReason` | `string` Output only. Has the reason a user account is suspended either by the administrator or by Google at the time of suspension. The property is returned only if the `suspended` property is `true`. |
| `thumbnailPhotoUrl` | `string` Output only. The URL of the user's profile photo. The URL might be temporary or private. |
| `languages` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of the user's languages. The maximum allowed data size is 1KB. <br /> |---|---|---| | **Fields** ||| | <br /> `languages[].customLanguage` <br /> | <br /> `string` <br /> | Other language. User can provide their own language name if there is no corresponding ISO 639 language code. If this is set, `languageCode` can't be set. | | <br /> `languages[].languageCode` <br /> | <br /> `string` <br /> | ISO 639 string representation of a language. See [Language Codes](https://developers.google.com/workspace/admin/directory/v1/languages) for the list of supported codes. Valid language codes outside the supported set will be accepted by the API but may lead to unexpected behavior. Illegal values cause `SchemaException`. If this is set, `customLanguage` can't be set. | | <br /> `languages[].preference` <br /> | <br /> `string` <br /> | Optional. If present, controls whether the specified `languageCode` is the user's preferred language. If `customLanguage` is set, this can't be set. Allowed values are `preferred` and `not_preferred`. | <br /> |
| `posixAccounts` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of [POSIX](http://www.opengroup.org/austin/papers/posix_faq.html) account information for the user. <br /> |---|---|---| | **Fields** ||| | <br /> `posixAccounts[].accountId` <br /> | <br /> `string` <br /> | A POSIX account field identifier. | | <br /> `posixAccounts[].gecos` <br /> | <br /> `string` <br /> | The [GECOS (user information)](https://en.wikipedia.org/wiki/Gecos_field) for this account. | | <br /> `posixAccounts[].gid` <br /> | <br /> `unsigned long` <br /> | The default [group ID](https://en.wikipedia.org/wiki/Group_identifier). | | <br /> `posixAccounts[].homeDirectory` <br /> | <br /> `string` <br /> | The path to the home directory for this account. | | <br /> `posixAccounts[].operatingSystemType` <br /> | <br /> `string` <br /> | The operating system type for this account. Acceptable values: `linux`, `unspecified`, `windows`. | | <br /> `posixAccounts[].primary` <br /> | <br /> `boolean` <br /> | If this is user's primary account within the SystemId. | | <br /> `posixAccounts[].shell` <br /> | <br /> `string` <br /> | The path to the login shell for this account. | | <br /> `posixAccounts[].systemId` <br /> | <br /> `string` <br /> | System identifier for which account Username or Uid apply to. | | <br /> `posixAccounts[].uid` <br /> | <br /> `unsigned long` <br /> | The POSIX compliant user ID. | | <br /> `posixAccounts[].username` <br /> | <br /> `string` <br /> | The username of the account. | <br /> |
| `creationTime` | `string` Output only. The time the user's account was created. The value is in [ISO 8601](https://www.w3.org/TR/NOTE-datetime) date and time format. The time is the complete date plus hours, minutes, and seconds in the form `YYYY-MM-DDThh:mm:ssTZD`. For example, `2010-04-05T17:30:04+01:00`. |
| `nonEditableAliases[]` | `string` Output only. The list of the user's non-editable alias email addresses. These are typically outside the account's primary domain or sub-domain. |
| `sshPublicKeys` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> A list of SSH public keys. <br /> |---|---|---| | **Fields** ||| | <br /> `sshPublicKeys[].expirationTimeUsec` <br /> | <br /> `long` <br /> | An expiration time in microseconds since epoch. | | <br /> `sshPublicKeys[].fingerprint` <br /> | <br /> `string` <br /> | A SHA-256 fingerprint of the SSH public key. (Read-only) | | <br /> `sshPublicKeys[].key` <br /> | <br /> `string` <br /> | An SSH public key. | <br /> |
| `notes` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> Notes for the user as a nested object. <br /> |---|---|---| | **Fields** ||| | <br /> `notes.contentType` <br /> | <br /> `string` <br /> | Content type of note, either plain text or HTML. Default is plain text. Acceptable values: `text_plain`, `text_html`. | | <br /> `notes.value` <br /> | <br /> `string` <br /> | Contents of notes. | <br /> |
| `websites` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of the user's websites. <br /> |---|---|---| | **Fields** ||| | <br /> `websites[].customType` <br /> | <br /> `string` <br /> | If the website `type` is `custom`, this property contains the custom value and must be set. | | <br /> `websites[].primary` <br /> | <br /> `boolean` <br /> | If `true`, this is the user's primary website. | | <br /> `websites[].type` <br /> | <br /> `string` <br /> | The type or purpose of the website. For example, a website could be labeled as `home` or `blog`. Alternatively, an entry can have a `custom` type. If set to `custom`, `customType` must also be set. Acceptable values: `app_install_page`, `blog`, `custom`, `ftp`, `home`, `home_page`, `other`, `profile`, `reservations`, `resume`, `work`. | | <br /> `websites[].value` <br /> | <br /> `string` <br /> | The URL of the website. | <br /> |
| `locations` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of the user's locations. The maximum allowed data size is 10KB. <br /> |---|---|---| | **Fields** ||| | <br /> `locations[].area` <br /> | <br /> `string` <br /> | Required. Textual location. This is most useful for display purposes to concisely describe the location. For example, `Mountain View, CA` or `Near Seattle`. | | <br /> `locations[].buildingId` <br /> | <br /> `string` <br /> | Building identifier. | | <br /> `locations[].customType` <br /> | <br /> `string` <br /> | If the location `type` is `custom`, this property contains the custom value and must be set. | | <br /> `locations[].deskCode` <br /> | <br /> `string` <br /> | Most specific textual code of individual desk location. | | <br /> `locations[].floorName` <br /> | <br /> `string` <br /> | Floor name/number. | | <br /> `locations[].floorSection` <br /> | <br /> `string` <br /> | Floor section. More specific location within the floor. For example, if a floor is divided into sections `A`, `B`, and `C`, this field would identify one of those values. | | <br /> `locations[].type` <br /> | <br /> `string` <br /> | The location type. If set to `custom`, `customType` must also be set. Acceptable values: `custom`, `default`, `desk`. | <br /> |
| `includeInGlobalAddressList` | `boolean` Indicates if the user's profile is visible in the Google Workspace global address list when the contact sharing feature is enabled for the domain. For more information about excluding user profiles, see the [administration help center](https://support.google.com/a/answer/1285988). |
| `keywords` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The list of the user's keywords. The maximum allowed data size is 1KB. <br /> |---|---|---| | **Fields** ||| | <br /> `keywords[].customType` <br /> | <br /> `string` <br /> | If the keyword `type` is `custom`, this property contains the custom value and must be set. | | <br /> `keywords[].type` <br /> | <br /> `string` <br /> | Each entry can have a type which indicates standard type of that entry. For example, keyword could be of type `occupation` or `outlook`. In addition to the standard type, an entry can have a `custom` type and can give it any name. If set to `custom`, `customType` must also be set. Acceptable values: `custom`, `mission`, `occupation`, `outlook`. | | <br /> `keywords[].value` <br /> | <br /> `string` <br /> | Keyword. | <br /> |
| `deletionTime` | `string` Output only. The time the user's account was deleted. The value is in [ISO 8601](https://www.w3.org/TR/NOTE-datetime) date and time format. The time is the complete date plus hours, minutes, and seconds in the form `YYYY-MM-DDThh:mm:ssTZD`. For example `2010-04-05T17:30:04+01:00`. |
| `gender` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> A nested object containing the user's gender. Maximum allowed data size for this field is 1KB. <br /> |---|---|---| | **Fields** ||| | <br /> `gender.addressMeAs` <br /> | <br /> `string` <br /> | A human-readable string containing the proper way to refer to the profile owner by humans, for example "he/him/his" or "they/them/their." | | <br /> `gender.customGender` <br /> | <br /> `string` <br /> | Name of a custom gender. | | <br /> `gender.type` <br /> | <br /> `string` <br /> | The type of gender. Acceptable values: - `female` - `male` - `other` - `unknown` | <br /> |
| `thumbnailPhotoEtag` | `string` Output only. ETag of the user's photo (Read-only) |
| `ims` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> The user's Instant Messenger (IM) accounts. A user account can have multiple `ims` properties, but only one of these `ims` properties can be the primary IM contact. <br /> |---|---|---| | **Fields** ||| | <br /> `ims[].customProtocol` <br /> | <br /> `string` <br /> | If the protocol value is `custom_protocol`, this property holds the custom protocol's string. | | <br /> `ims[].customType` <br /> | <br /> `string` <br /> | If the IM `type` is `custom`, this property contains the custom value and must be set. | | <br /> `ims[].im` <br /> | <br /> `string` <br /> | The user's IM network ID. | | <br /> `ims[].primary` <br /> | <br /> `boolean` <br /> | If this is the user's primary IM. Only one entry in the IM list can have a value of true. | | <br /> `ims[].protocol` <br /> | <br /> `string` <br /> | An IM protocol identifies the IM network. The value can be a custom network or the standard network. Acceptable values: - `aim`: AOL Instant Messenger protocol - `custom_protocol`: A custom IM network protocol - `gtalk`: Google Talk protocol - `icq`: ICQ protocol - `jabber`: Jabber protocol - `msn`: MSN Messenger protocol - `net_meeting`: Net Meeting protocol - `qq`: QQ protocol - `skype`: Skype protocol - `yahoo`: Yahoo Messenger protocol | | <br /> `ims[].type` <br /> | <br /> `string` <br /> | The type of IM account. If set to `custom`, `customType` must also be set. Acceptable values: `custom`, `home`, `other`, `work`. | <br /> |
| `customSchemas` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` <br /> Custom fields of the user. The key is a `schemaName` and its values are `'fieldName': 'field_value'`. - `customSchemas.(key)` is a nested object. - `customSchemas.(key).(key)` can be any value. |
| `isEnrolledIn2Sv` | `boolean` Output only. Is enrolled in 2-step verification (Read-only) |
| `isEnforcedIn2Sv` | `boolean` Output only. Is 2-step verification enforced (Read-only) |
| `archived` | `boolean` Indicates if user is archived. |
| `orgUnitPath` | `string` The full path of the parent organization associated with the user. If the parent organization is the top-level, it is represented as a forward slash (`/`). |
| `recoveryEmail` | `string` Recovery email of the user. |
| `recoveryPhone` | `string` Recovery phone of the user. The phone number must be in the E.164 format, starting with the plus sign (+). Example: *+16506661212*. |
| `isGuestUser` | `boolean` Immutable. Indicates if the inserted user is a guest. |
| `guestAccountInfo` | ``object (`https://developers.google.com/workspace/admin/directory/reference/rest/v1/users#GuestAccountInfo`)`` Immutable. Additional guest-related metadata fields |
| `suspensionTime` | `string` Output only. User's account suspension time. (Read-only) |
| `archivalTime` | `string` Output only. User's account archival time. (Read-only) |

## UserName

| JSON representation |
|---|
| ``` { "fullName": string, "familyName": string, "givenName": string, "displayName": string } ``` |

| Fields ||
|---|---|
| `fullName` | `string` The user's full name formed by concatenating the first and last name values. |
| `familyName` | `string` The user's last name. Required when creating a user account. |
| `givenName` | `string` The user's first name. Required when creating a user account. |
| `displayName` | `string` The user's display name. Limit: 256 characters. |

## GuestAccountInfo

Account info specific to Guest users.

| JSON representation |
|---|
| ``` { "primaryGuestEmail": string } ``` |

| Fields ||
|---|---|
| `primaryGuestEmail` | `string` Immutable. The guest's external email. |

| ## Methods ||
|---|---|
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/createGuest` | Create a guest user with access to a [subset of Workspace capabilities](https://support.google.com/a/answer/16558545). |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/delete` | Deletes a user. |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/get` | Retrieves a user. |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/insert` | Creates a user. |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/list` | Retrieves a paginated list of either deleted users or all users in a domain. |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/makeAdmin` | Makes a user a super administrator. |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/patch` | Updates a user using patch semantics. |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/signOut` | Signs a user out of all web and device sessions and reset their sign-in cookies. |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/undelete` | Undeletes a deleted user. |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/update` | Updates a user. |
| ### `https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/watch` | Watches for changes in users list. |